#
rm(list = ls())

#charger la librairie
library(OpenStreetMap)

#carte de Madagascar
map <- openmap(upperLeft = c(-9, 43), lowerRight = c(-29, 51),zoom=5,type="osm")
print(map)

#affichage de la carte
autoplot.OpenStreetMap(map)

#package jsonlite
library(jsonlite)

#informations Antananarivo
infoTana <- jsonlite::fromJSON("https://nominatim.openstreetmap.org/search/@Antananarivo@?adressdetails=0&format=json")
str(infoTana)

#informations Fianarantsoa
infoFianar <- jsonlite::fromJSON("https://nominatim.openstreetmap.org/search/@Fianarantsoa@?adressdetails=0&format=json")
str(infoFianar)

#package osrm
library(osrm)

#information sur la distance routire entre les deux villes
res <- osrm::osrmRoute(src=c("Tana",infoTana$lon[1],infoTana$lat[1]),dst=c("Fianar",infoFianar$lon[1],infoFianar$lat[1]),sp=TRUE)
print(res)

#information sur le trajet entre les deux villes
trajet <- osrm::osrmRoute(src=c("Tana",infoTana$lon[1],infoTana$lat[1]),dst=c("Fianar",infoFianar$lon[1],infoFianar$lat[1]),sp=FALSE)
print(head(trajet))

#coordonnes en (x,y) du trajet
xy <- data.frame(OpenStreetMap::projectMercator(trajet$lat,trajet$lon))
print(head(xy))

#package ggplot2
library(ggplot2)

#ajouter le trajet dans la carte
autoplot.OpenStreetMap(map) + geom_path(mapping=aes(x,y),data=xy,size=1,col="red")
